//Mandelbulb mit Voxeln 
//Tastaturbefehle siehe Programmcode
//Programmieren lernen mit Computergrafik
//Deussen, Ningelgen

import peasy.*;

ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
PeasyCam cam;
int BildHB;
int anzahlSchritte; //Schritte in dritter Koordinate
int aT = 12;//Anzahl Threads
float cB;//Cubebreite
ArrayList<MandelPoint> mandelbulb = new ArrayList<MandelPoint>();
ArrayList<MandelPoint> temp = new ArrayList<MandelPoint>();
StringList points;
int maxiterations = 8;
int wahlSichtR;//Bestimmung der Sichtrichtung
float farbWert;
float farbFaktor;
float RF,RG; //Farbe und Grauwert
boolean lichtV,lichtH,lichtR,lichtL,lichtO,lichtU;
boolean vV,vH,vL,vR,vO,vU;
boolean loeschen;
float dWX, dWY; //Drehwinkel um x- bzw y-Achse
float R; //Abstand vom Ursprung
int anzahlPunkte =0;
boolean haelfteAnzeigen = false;

void setup() {
  size(400, 400, P3D);
  BildHB = width; 
  anzahlSchritte = width;
  colorMode(HSB, 255);
  cam = new PeasyCam(this,500);
  points = new StringList();
  cB = 1; 
  farbWert=random(50,255);
  farbFaktor = 1.2;
  vU=true;//Beim Start Sicht von unten     
  vV=false;vL=false;vO=false;vH=false;vR=false;
  lichtO=true; lichtH=true; lichtV=true;  lichtU=true; lichtR=true; lichtL=true;//alle Lichter an
  loeschen = false;
  System.gc();
  starten();
  //Um mandelpoints auszugeben:
  //String[] output = points.toArray();
  //saveStrings("mandelbulb.txt", output);
 
}

void draw() {
  background(0);
   
  rotateX(dWX);
  rotateY(dWY);
  //Lichter:
  if(lichtV) directionalLight(0, 0, 255, 0, 0, -1); 
  if(lichtH) directionalLight(0, 0, 255, 0, 0,  1);
  if(lichtR) directionalLight(0, 0, 255,-1, 0,  0);
  if(lichtL) directionalLight(0, 0, 255, 1, 0,  0);
  if(lichtO) directionalLight(0, 0, 255, 0,-1,  0); 
  if(lichtU) directionalLight(0, 0, 255, 0, 1,  0); 

  if(haelfteAnzeigen){
    for (MandelPoint m : mandelbulb) {
      if(m.v.y>0){
        pushMatrix();
          translate(m.v.x, m.v.y, m.v.z);  
          noStroke();// 
          R=sqrt(m.v.x*m.v.x+m.v.y*m.v.y+m.v.z*m.v.z); //print(R+"   ");
          RF=(farbWert+farbFaktor*R)%256;
          RG=1.4*R;if(RG>255)RG=255;
          fill(RF,255,RG);
          box(cB);//sphere(cB);// sphere sehr langsam
       popMatrix();
      }
    }
  }else{
    for (MandelPoint m : mandelbulb) {    
        pushMatrix();
          translate(m.v.x, m.v.y, m.v.z);  
          noStroke();// 
          R=sqrt(m.v.x*m.v.x+m.v.y*m.v.y+m.v.z*m.v.z); 
          RF=(farbWert+farbFaktor*R)%256;
          RG=1.4*R;if(RG>255)RG=255;
          fill(RF,255,RG);
          box(cB);//sphere(cB);// sphere sehr langsam
       popMatrix();   
    }    
  } 
}

void starten(){
   if(loeschen) { mandelbulb.clear();temp.clear();}   
  
   
   if(vR || vL) {wahlSichtR = 1; if(vR) {dWX=0; dWY=-PI/2;} else {dWX=0; dWY = PI/2;}}
    else if(vH || vV){ wahlSichtR =2; if(vV){dWX=0; dWY=0;} else{dWX=0; dWY = PI;}}
     else if(vO || vU){ wahlSichtR =3; if(vO){dWX=PI/2; dWY=0;} else{dWX=-PI/2; dWY=0;}}
 
   multiThreadsStarten();
   anzahlPunkte =  mandelbulb.size();
   println("Anzahl Punkte in mandelbulb: "+anzahlPunkte);
   println("Winkel dWX: "+dWX+" Winkel dWY: "+dWY);
}

void multiThreadsStarten(){
   workers.clear();
   for (int i=0; i<12; i++)
    {
      workers.add(new WorkThread(i)); 
    }
    for (WorkThread worker : workers) {  
      while (worker.running)
      {       
        try{
        Thread.sleep(10);  
        }catch (Exception e) {  }  ;                
      }
    }
    temp = workers.get(0).punkte00;    
    println("Übertragene Anzahl  0: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(1).punkte01;    
    println("Übertragene Anzahl  1: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(2).punkte02;    
    println("Übertragene Anzahl  2: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(3).punkte03;    
    println("Übertragene Anzahl  3: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(4).punkte04;    
    println("Übertragene Anzahl  4: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(5).punkte05;    
    println("Übertragene Anzahl  5: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(6).punkte06;    
    println("Übertragene Anzahl  6: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(7).punkte07;    
    println("Übertragene Anzahl  7: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(8).punkte08;    
    println("Übertragene Anzahl  8: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(9).punkte09;    
    println("Übertragene Anzahl  9: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(10).punkte10;    
    println("Übertragene Anzahl 10: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
    temp = workers.get(11).punkte11;    
    println("Übertragene Anzahl 11: "+temp.size());
    for(MandelPoint punkt: temp){
        mandelbulb.add(punkt);
    }
}

Spherical spherical(float x, float y, float z) {
  float r = sqrt(x*x + y*y + z*z);
  float theta = atan2( sqrt(x*x+y*y), z);
  float phi = atan2(y, x);
  return new Spherical(r, theta, phi);
}

void keyPressed(){
    if(key=='o') {lichtO=!lichtO;println("Licht von oben: "+lichtO);}
    if(key=='u') {lichtU=!lichtU;println("Licht von unten "+lichtU);}
    if(key=='l') {lichtL=!lichtL;println("Licht von links "+lichtL);}
    if(key=='r') {lichtR=!lichtR;println("Licht von rechts "+lichtR);}
    if(key=='v') {lichtV=!lichtV;println("Licht von vorn "+lichtV);}
    if(key=='h') {lichtH=!lichtH;println("Licht von hinten "+lichtH);}
    if(key=='O') {wahlSichtR =3;vR=false;vL=false;vH=false;vV=false;vU=false;vO=true;starten() ;}
    if(key=='U') {wahlSichtR =3;vR=false;vL=false;vH=false;vV=false;vU=true;vO=false;starten();}
    if(key=='L') {wahlSichtR =1;vR=false;vL=true;vH=false;vV=false;vU=false;vO=false;starten() ;}
    if(key=='R') {wahlSichtR =1;vR=true;vL=false;vH=false;vV=false;vU=false;vO=false;starten();}
    if(key=='V') {wahlSichtR =2;vR=false;vL=false;vH=false;vV=true;vU=false;vO=false;starten() ;}
    if(key=='H') {wahlSichtR =2;vR=false;vL=false;vH=true;vV=false;vU=false;vO=false;starten() ;}
    if(key=='s') {saveFrame("Bild-##.png"); println("Bild gespeichert");}
    if(key=='*') {cB =2*cB;println("Cube-Breite; "+cB);}
    if(key=='/') {cB =cB/2;println("Cube-Breite; "+cB);}
    if(key=='n') {loeschen =!loeschen;}
    if(key=='2') {
      haelfteAnzeigen=!haelfteAnzeigen;
      if(haelfteAnzeigen)println("Es wird nur der halbe Mandelbulb angezeigt!");
    }
    if(key=='F') { farbFaktor = farbFaktor*1.4; println("Farbfaktor: "+farbFaktor);}}
   
class MandelPoint {
  PVector v;
 
  MandelPoint(PVector v) {
    this.v = v;
  }
}

class Spherical {
  float r, theta, phi;
  Spherical(float r, float theta, float phi) {
    this.r = r;
    this.theta = theta;
    this.phi = phi;
  }
}

////////////////////////////////////////////////////////////////////////////////////////////////
class WorkThread implements Runnable {
 
  protected boolean running = true;
  private int nummer;
   
  ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
 
  ArrayList<MandelPoint> punkte00 = new ArrayList<MandelPoint>(); 
  ArrayList<MandelPoint> punkte01 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte02 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte03 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte04 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte05 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte06 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte07 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte08 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte09 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte10 = new ArrayList<MandelPoint>();
  ArrayList<MandelPoint> punkte11 = new ArrayList<MandelPoint>();

  public WorkThread (int nummer){
  
    this.nummer = nummer;
    Thread thread = new Thread(this);
    thread.start();
  }
  
  public void run() {  
    
    this.running = true;
    println("Die interne Threadnummer ist: " 
     + Thread.currentThread().getId() + ", Eigene Threadnummer: " + nummer);
    
   
    switch(nummer){  
      case 0:punkteBerechnen( 0); break;              
      case 1:punkteBerechnen( 1); break;                
      case 2:punkteBerechnen( 2); break;                 
      case 3:punkteBerechnen( 3); break;            
      case 4:punkteBerechnen( 4); break;            
      case 5:punkteBerechnen( 5); break;          
      case 6:punkteBerechnen( 6); break;       
      case 7:punkteBerechnen( 7); break;            
      case 8:punkteBerechnen( 8); break;       
      case 9:punkteBerechnen( 9); break;          
      case 10:punkteBerechnen(10); break;            
      case 11:punkteBerechnen(11); break;       
    }
    println("Threads mit Nummer "+nummer+" ist fertig!");   
    this.running = false;
  }
  
   void punkteBerechnen(int I){
     int aP = BildHB/aT; //Anteil Punkte //println(aT);
     float b; 
    
   for (int i = I*aP; i < (I+1)*aP; i++) {
     for (int j = 0; j < BildHB; j++) {
    
      boolean treffer = false;
      float x =0;
      float y =0;
      float z =0;
      
      for (int k = 0; k < anzahlSchritte; k++) {
        
        switch(wahlSichtR){
        
         case 1: 
                y = map(i, 0, BildHB, -1.1, 1.1);
                z = map(j, 0, BildHB, -1.1, 1.1);
                if(vR) x = map(k, 0, anzahlSchritte, 1.1, -1.1);
                if(vL) x = map(k, 0, anzahlSchritte, -1.1, 1.1);
                break;
         
         case 2:
                x = map(i, 0, BildHB, -1.1, 1.1);
                y = map(j, 0, BildHB, -1.1, 1.1);
                if(vH) z = map(k, 0, anzahlSchritte, -1.1, 1.1);
                if(vV) z = map(k, 0, anzahlSchritte, 1.1, -1.1);
                break;
         
         case 3:
               x = map(i, 0, BildHB, -1.1, 1.1);
               z = map(j, 0, BildHB, -1.1, 1.1);
               if(vU) y = map(k, 0, anzahlSchritte, -1.1, 1.1);
               if(vO) y = map(k, 0, anzahlSchritte, 1.1, -1.1);
               break;          
        }
          

        PVector zeta = new PVector(0, 0, 0);
        int n = 8;
        int iteration = 0;
        
        while (true) {
          Spherical c = spherical(zeta.x, zeta.y, zeta.z);
          float newx = pow(c.r, n) * sin(c.theta*n) * cos(c.phi*n);
          float newy = pow(c.r, n) * sin(c.theta*n) * sin(c.phi*n);
          float newz = pow(c.r, n) * cos(c.theta*n);
          zeta.x = newx + x;
          zeta.y = newy + y;
          zeta.z = newz + z;
          iteration++;
          b = c.r;
          if (b > 2) {//Divergenz         
            break;
          }
          if (iteration > maxiterations) {
            if (!treffer) {
              treffer = true; 
              punktHinzu(I,(new MandelPoint(new PVector(x*200, y*200, z*200))));            
           }
            break;
          }          
        }//end of while
      }
     }//end of for j
   }//end of for i    
 }
  
  void punktHinzu(int n, MandelPoint p){    
    switch(n){
      case  0: punkte00.add(p); break;
      case  1: punkte01.add(p); break;
      case  2: punkte02.add(p); break;
      case  3: punkte03.add(p); break;
      case  4: punkte04.add(p); break;
      case  5: punkte05.add(p); break;
      case  6: punkte06.add(p); break;
      case  7: punkte07.add(p); break;
      case  8: punkte08.add(p); break;
      case  9: punkte09.add(p); break;
      case 10: punkte10.add(p); break;
      case 11: punkte11.add(p); break;
    }   
  } 
}
